/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.dbswing;

import com.sun.java.swing.*;
import com.sun.java.swing.beaninfo.*;
import java.beans.*;
import java.awt.*;

public class JdbComboBoxBeanInfo extends SwingBeanInfo
{
  private static final Class classJdbComboBox = borland.dbswing.JdbComboBox.class;

  public BeanDescriptor getBeanDescriptor() {
    return createBeanDescriptor(classJdbComboBox, new Object[] {
      PREFERRED, Boolean.TRUE,
      SHORTDESCRIPTION, "JdbComboBox",
      "isContainer", Boolean.FALSE});
  }

  public PropertyDescriptor[] getPropertyDescriptors() {
    PropertyDescriptor dataSet =
      createPropertyDescriptor(classJdbComboBox, "dataSet", new Object[] {
        SHORTDESCRIPTION, "The DataSet data source"});
    PropertyDescriptor items =
      createPropertyDescriptor(classJdbComboBox, "items", new Object[] {
        SHORTDESCRIPTION, "Item list"});
    PropertyDescriptor columnName =
      createPropertyDescriptor(classJdbComboBox, "columnName", new Object[] {
        SHORTDESCRIPTION, "The column name in the DataSet"});
    return new PropertyDescriptor[] {dataSet, columnName, items};
  }

  public Image getIcon(int kind) {
    if (kind == ICON_COLOR_16x16)
      return loadImage("image/JdbComboBox_Color16.gif"); // NORES
    else if (kind == ICON_COLOR_32x32)
      return loadImage("image/JdbComboBox_Color32.gif"); // NORES
    return super.getIcon(kind);
  }
}


