/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.dbswing;

import java.awt.*;
import com.sun.java.swing.*;
import borland.jbcl.util.*;
import borland.jbcl.model.*;
import borland.jbcl.dataset.*;

public class dbListCellRenderer extends JLabel implements ListCellRenderer
{
  public dbListCellRenderer() {
    super();
  }

  public dbListCellRenderer(ItemFormatter formatter) {
    super();
    this.formatter = formatter;
  }

  public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
    setText(getText(value));
    if (isSelected) {
      setBackground(SystemColor.textHighlight);
      setForeground(SystemColor.textHighlightText);
    }
    else {
      setBackground(null);
      setForeground(null);
    }
    return this;
  }

  /**
   * Formatter property defines the ItemFormatter to use to format the text passed in the
   * getPreferredSize and paint methods.
   * @see borland.jbcl.model.ItemFormatter for more info.
   */
  public void setFormatter(ItemFormatter formatter) {
    this.formatter = formatter;
  }
  public ItemFormatter getFormatter() {
    return formatter;
  }

  protected String getText(Object data) {
    if (data != null) {
      if (formatter != null && data instanceof Variant) {
        try {
          return formatter.format(data);
        }
        catch (InvalidFormatException ex) {
          Diagnostic.printStackTrace(ex);
          return "";
        }
      }
      else
        return data.toString();
    }
    else
      return "";
  }

  protected ItemFormatter formatter;
}
