/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.dbswing;

import com.sun.java.swing.*;
import borland.jbcl.dataset.*;
import java.awt.Component;
import borland.jbcl.util.Variant;

public class dbListModel extends AbstractListModel implements DataChangeListener
{
  public dbListModel(DataSet dataSet, String columnName, Component component) {
    super();
    this.dataSet = dataSet;
    this.columnName = columnName;
    this.component = component;
    dataSet.addDataChangeListener(this);
  }

  public int getSize() {
    try {
      return dataSet.getRowCount();
    }
    catch (Exception ex) {
      handleException(ex);
      return 0;
    }
  }

  public Object getElementAt(int index) {
    try {
      dataSet.getVariant(columnName, index, value);
      return value;
    }
    catch (Exception ex) {
      handleException(ex);
      value.setUnassignedNull();
      return value;
    }
  }

  final void handleException(Exception ex) {
    DataSetException.handleException(dataSet, component, ex);
  }

  // event translation

  public void dataChanged(DataChangeEvent e) {
    int row = e.getRowAffected();
    if (row < 0 || row >= getSize()) {
      fireContentsChanged(this, 0, getSize() - 1);
      return;
    }
    switch(e.getID()) {
      case e.ROW_ADDED:
        fireIntervalAdded(this, row, row);
        break;
      case e.ROW_DELETED:
        fireIntervalRemoved(this, row, row);
        break;
      case e.ROW_CHANGED:
      case e.ROW_CHANGE_POSTED:
        fireContentsChanged(this, row, row);
        break;
      default:
        fireContentsChanged(this, 0, getSize() - 1);
    }
  }

  public void postRow(DataChangeEvent e) throws Exception {
    // Handled directly by controls.
  }

  protected DataSet dataSet;
  protected String columnName;
  protected Component component;
  protected Variant value = new Variant();
}
