/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.dbswing;

import java.awt.*;
import com.sun.java.swing.*;
import borland.jbcl.util.*;
import borland.jbcl.dataset.*;

public class dbNavComboBoxModel extends dbListModel implements ComboBoxModel
{
  public dbNavComboBoxModel(DataSet dataSet, String columnName, Component component) {
    super(dataSet, columnName, component);
  }

  public void setSelectedItem(Object anObject) {
//    System.err.println("dbNavComboBoxModel.setSelectedItem(" + anObject + ")");
    Object obj = anObject;
    if (anObject instanceof Variant) {
      obj = ((Variant)anObject).clone();
//      System.err.println(" cloned data: " + obj);
    }
    int row = dataSet.getRow();
    for (int i = 0; i < getSize(); i++) {
      Object data = getElementAt(i);
//      System.err.println(" checking " + i + ": \"" + data + "\"");
//      if (obj != null)
//        System.err.println(" obj.equals(data) == [" + obj + "].equals([" + data + "]) == " + obj.equals(data));
      String a = obj != null ? obj.toString() : "";
      String b = data != null ? data.toString() : "";
//      if (obj == data || obj != null && obj.equals(data)) {
      if (a.equals(b)) {
//        System.err.println(" data is EQUAL! checking row...");
        if (row != i) {
//          System.err.println(" row is different");
          try {
//            System.err.println(" attempting navigate");
            dataSet.goToRow(i);
          }
          catch (DataSetException x) {
//            System.err.println(" navigate FAILED!");
          }
        }
        return;
      }
    }
  }

  public Object getSelectedItem() {
    Variant value = new Variant();
    try {
      dataSet.getVariant(columnName, value);
    }
    catch (DataSetException x) {
      value.setUnassignedNull();
    }
    return value;
  }
}
