/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.dbswing;

import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import borland.jbcl.dataset.*;
import java.awt.Component;
import borland.jbcl.util.Variant;

public class dbTableModel extends AbstractTableModel implements DataChangeListener
{
  public dbTableModel(DataSet dataSet, Component component) {
    super();
    this.dataSet = dataSet;
    this.component = component;
    dataSet.addDataChangeListener(this);
  }

  public int getRowCount() {
    try {
      return dataSet.getRowCount();
    }
    catch (Exception ex) {
      handleException(ex);
      return 0;
    }
  }

  public int getColumnCount() {
    try {
      return dataSet.getColumnCount();
    }
    catch (Exception ex) {
      handleException(ex);
      return 0;
    }
  }

  public String getColumnName(int columnIndex) {
    try {
      return dataSet.getColumn(columnIndex).getColumnName();
    }
    catch (DataSetException x) {
      return "";
    }
  }

  public Class getColumnClass(int columnIndex) {
    return String.class;
  }

  public boolean isCellEditable(int rowIndex, int columnIndex) {
    return false;
  }

  public Object getValueAt(int row, int column) {
    try {
      // NOTE THESE ARE REVERSED (row and column)
      dataSet.getVariant(column, row, value);
      return value;
    }
    catch (Exception ex) {
      handleException(ex);
      value.setUnassignedNull();
      return value;
    }
  }

  public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
  }

  final void handleException(Exception ex) {
    DataSetException.handleException(dataSet, component, ex);
  }

  // event translation

  public void dataChanged(DataChangeEvent e) {
    int row = e.getRowAffected();
    switch(e.getID()) {
      case e.ROW_ADDED:
        fireTableRowsInserted(row, row);
        break;
      case e.ROW_DELETED:
        fireTableRowsDeleted(row, row);
        break;
      case e.ROW_CHANGED:
      case e.ROW_CHANGE_POSTED:
        fireTableRowsUpdated(row, row);
        break;
      default:
        fireTableDataChanged();
    }
  }

/*
  fireTableDataChanged()
  fireTableStructureChanged()
  fireTableRowsInserted(int firstRow, int lastRow)
  fireTableRowsUpdated(int firstRow, int lastRow)
  fireTableRowsDeleted(int firstRow, int lastRow)
  fireTableCellUpdated(int row, int column)
  fireTableChanged(TableModelEvent e)
*/

  public void postRow(DataChangeEvent e) throws Exception {
    // Handled directly by controls.
  }

  protected DataSet dataSet;
  protected Component component;
  protected Variant value = new Variant();
}
