/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.control;

import borland.jbcl.util.BasicBeanInfo;

public class GridControlBeanInfo extends BasicBeanInfo implements java.io.Serializable
{
  public GridControlBeanInfo() {
    beanClass = GridControl.class;
    propertyDescriptors = new String[][] {
      {"autoAppend",          Res.getString(Res.BI_Grid_autoAppend), "isAutoAppend", "setAutoAppend"},
      {"autoEdit",            Res.getString(Res.BI_autoEdit), "isAutoEdit", "setAutoEdit"},
      {"autoInsert",          Res.getString(Res.BI_autoInsert), "isAutoInsert", "setAutoInsert"},
      {"background",          Res.getString(Res.BI_background), "getBackground", "setBackground"},
      {"columnHeaderHeight",  Res.getString(Res.BI_Grid_columnHeaderHeight), "getColumnHeaderHeight", "setColumnHeaderHeight"},
      {"columnHeaderVisible", Res.getString(Res.BI_Grid_columnHeaderVisible), "isColumnHeaderVisible", "setColumnHeaderVisible"},
      {"columnCaptions",      Res.getString(Res.BI_Grid_columnCaptions), "getColumnCaptions", "setColumnCaptions"}, // String[]
      {"dataSet",             Res.getString(Res.BI_dataSet), "getDataSet", "setDataSet"},
      {"dataToolTip",         Res.getString(Res.BI_dataToolTip), "isDataToolTip", "setDataToolTip"},
      {"defaultColumnWidth",  Res.getString(Res.BI_Grid_defaultColumnWidth), "getDefaultColumnWidth", "setDefaultColumnWidth"},
      {"doubleBuffered",      Res.getString(Res.BI_doubleBuffered), "isDoubleBuffered", "setDoubleBuffered"},
      {"dragSubfocus",        Res.getString(Res.BI_dragSubfocus), "isDragSubfocus", "setDragSubfocus"},
      {"editInPlace",         Res.getString(Res.BI_editInPlace), "isEditInPlace", "setEditInPlace"},
      {"enabled",             Res.getString(Res.BI_enabled), "isEnabled", "setEnabled"},
      {"font",                Res.getString(Res.BI_font), "getFont", "setFont"},
      {"foreground",          Res.getString(Res.BI_foreground), "getForeground", "setForeground"},
      {"growEditor",          Res.getString(Res.BI_growEditor), "isGrowEditor", "setGrowEditor"},
      {"gridLineColor",       Res.getString(Res.BI_Grid_gridLineColor), "getGridLineColor", "setGridLineColor"},
      {"gridVisible",         Res.getString(Res.BI_Grid_gridVisible), "isGridVisible", "setGridVisible"},
      {"horizontalLines",     Res.getString(Res.BI_Grid_horizontalLines), "isHorizontalLines", "setHorizontalLines"},
      {"horizontalScrollBarPolicy", Res.getString(Res.BI_SBPolicy), "getHorizontalScrollBarPolicy", "setHorizontalScrollBarPolicy", borland.jbcl.editors.HorizontalScrollBarPolicyEditor.class.getName()},
      {"items",               Res.getString(Res.BI_items), "getItems", "setItems"},
      {"moveableColumns",     Res.getString(Res.BI_Grid_moveableColumns), "isMoveableColumns", "setMoveableColumns"},
      {"multiSelect",         Res.getString(Res.BI_multiSelect), "isMultiSelect", "setMultiSelect"},
      {"navigateOnEnter",     Res.getString(Res.BI_Grid_navigateOnEnter), "isNavigateOnEnter", "setNavigateOnEnter"},
      {"navigateOnTab",       Res.getString(Res.BI_Grid_navigateOnTab), "isNavigateOnTab", "setNavigateOnTab"},
      {"navigateWithDataSet", Res.getString(Res.BI_navigateWithDataSet), "isNavigateWithDataSet", "setNavigateWithDataSet"},
      {"opaque",              Res.getString(Res.BI_opaque), "isOpaque", "setOpaque"},
      {"postOnEndEdit",       Res.getString(Res.BI_postOnEndEdit), "isPostOnEndEdit", "setPostOnEndEdit"},
      {"preferredSize",       Res.getString(Res.BI_preferredSize), "getPreferredSize", "setPreferredSize"},
      {"readOnly",            Res.getString(Res.BI_readOnly), "isReadOnly", "setReadOnly"},
      {"resizableColumns",    Res.getString(Res.BI_Grid_resizableColumns), "isResizableColumns", "setResizableColumns"},
      {"resizableRows",       Res.getString(Res.BI_Grid_resizableRows), "isResizableRows", "setResizableRows"},
      {"rowHeaderVisible",    Res.getString(Res.BI_Grid_rowHeaderVisible), "isRowHeaderVisible", "setRowHeaderVisible"},
      {"rowHeaderWidth",      Res.getString(Res.BI_Grid_rowHeaderWidth), "getRowHeaderWidth", "setRowHeaderWidth"},
      {"selectColumn",        Res.getString(Res.BI_Grid_selectColumn), "isSelectColumn", "setSelectColumn"},
      {"selectRow",           Res.getString(Res.BI_Grid_selectRow), "isSelectRow", "setSelectRow"},
      {"showFocus",           Res.getString(Res.BI_showFocus), "isShowFocus", "setShowFocus"},
      {"showPopup",           Res.getString(Res.BI_showPopup), "isShowPopup", "setShowPopup"},
      {"showRollover",        Res.getString(Res.BI_showRollover), "isShowRollover", "setShowRollover"},
      {"sortOnHeaderClick",   Res.getString(Res.BI_Grid_sortOnHeaderClick), "isSortOnHeaderClick", "setSortOnHeaderClick"},
      {"subfocus",            Res.getString(Res.BI_Grid_subfocus), "getSubfocus", "setSubfocus", borland.jbcl.editors.MatrixLocationEditor.class.getName()},
      {"textureName",         Res.getString(Res.BI_texture), "getTextureName", "setTextureName", borland.jbcl.editors.FileNameEditor.class.getName()},
      {"toolTipText",         Res.getString(Res.BI_toolTipText), "getToolTipText", "setToolTipText"},
      {"verticalLines",       Res.getString(Res.BI_Grid_verticalLines), "isVerticalLines", "setVerticalLines"},
      {"verticalScrollBarPolicy", Res.getString(Res.BI_SBPolicy), "getVerticalScrollBarPolicy", "setVerticalScrollBarPolicy", borland.jbcl.editors.VerticalScrollBarPolicyEditor.class.getName()},
      {"visible",             Res.getString(Res.BI_visible), "isVisible", "setVisible"},
    };
  }
}
