/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//NOTTRANSLATABLE

package borland.jbcl.control.applet;

import java.util.*;
import java.net.*;
import java.applet.*;

class AppletViewerControlPanel extends AppletPanel
{
  URL documentURL;
  URL baseURL;
  Hashtable atts;
  
  AppletViewerControlPanel(URL documentURL, Hashtable atts) {
    this.documentURL = documentURL;
    this.atts = atts;
    
    String att = getParameter("codebase");
    if (att != null) {
      if (!att.endsWith("/"))
        att += "/";
      try {
        baseURL = new URL(documentURL, att);
      }
      catch (MalformedURLException e) {
      }
    }
    if (baseURL == null) {
      String file = documentURL.getFile();
      int i = file.lastIndexOf('/');
      if (i > 0 && i < file.length() - 1) {
        try {
          baseURL = new URL(documentURL, file.substring(0, i + 1));
        }
        catch (MalformedURLException e) {
        }
      }
    }
    if (baseURL == null)
      baseURL = documentURL;
  }

  public String getParameter(String name) {
    try {
      String namelower = name.toLowerCase(); // MUST have toLowerCase() for consistent hash
      Object o = atts.get(namelower);
      return o != null ? o.toString() : null;
    }
    catch (Exception e) {
      System.err.println("    **EXCEPTION in GETPARAMETER: "+e);
      return null;
    }
  }
  
  public URL getDocumentBase() {
    return documentURL;
  }
  
  public URL getCodeBase() {
    return baseURL;
  }
  
  public int getWidth() {
    String w = getParameter("width");
    if (w != null)
      return Integer.valueOf(w).intValue();
    return 100;
  }

  public int getHeight() {
    String h = getParameter("height");
    if (h != null)
      return Integer.valueOf(h).intValue();
    return 100;
  }
  
  public String getCode() {
    return getParameter("code");
  }
  
  public String getJarFiles() {
    return getParameter("archive");
  }
  
  public String getSerializedObject() {
    return getParameter("object");
  }
  
  public AppletContext getAppletContext() {
    return (AppletContext)getParent();
  }
}
