/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.dataset;

import borland.jbcl.util.Variant;
import java.util.*;

/**
    Column value editing events.
*/
public interface ColumnChangeListener extends EventListener
{
  /** Called before Column level validations like readOnly, min/max performed and
      before the new value is recorded in a ReadWriteRow.  To prevent the value from
      being set, throw an Exception (throw new VetoException()).  You can change the
      value stored in value, but it must still pass the Column level validations.

      If a VetoException is constructed with a String parameter, this String will
      be used in the default error handling displays.
      (ie throw new VetoException("My error message"))

      Note that if values are set programatically, EditMask constraints are not applied.
  */
  void validate(DataSet dataSet, Column column, Variant value) throws Exception, DataSetException;
  /** Called after a Column value has been successfully set inside a ReadWriteRow.
  */
  void changed(DataSet dataSet, Column column, Variant value) throws DataSetException;
}
