/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.dataset;

import borland.jbcl.util.Variant;
import borland.jbcl.model.CustomPaintSite;
import java.util.*;

/**
    @since JB2.0
    Wire this event to gain custom control over the painting of a
    Column value at a specific row location.
*/
public interface ColumnPaintListener extends EventListener
{
  /**
      @since JB2.0
      Note that display properties can be set on the incoming paintSite and the
      incoming value can also be modified.  If value is modified, it does not affect
      the value stored in the dataSet.  It only affects the value to be displayed.
  */
  void painting(DataSet dataSet, Column column, int row, Variant value, CustomPaintSite paintSite);

  /**
      @since JB2.0
      Note that display properties for the editor can be set on the incoming paintSite.
  */
  void editing(DataSet dataSet, Column column, CustomPaintSite paintSite);
}
