/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.jbcl.editors;

import borland.jbcl.util.*;

public class DataTypeEditor extends IntegerTagEditor
{
  public DataTypeEditor() {
    super(values, getResourceStrings(), sourceStrings, true);
  }

  // Order in this array MUST MATCH order in sourceStrings[] below
  static int[] values = {
    Variant.UNASSIGNED_NULL,
    Variant.ASSIGNED_NULL,
    Variant.BYTE,
    Variant.SHORT,
    Variant.INT,
    Variant.LONG,
    Variant.FLOAT,
    Variant.DOUBLE,
    Variant.BIGDECIMAL,
    Variant.BOOLEAN,
    Variant.INPUTSTREAM,
    Variant.DATE,
    Variant.TIME,
    Variant.TIMESTAMP,
    Variant.STRING,
    Variant.OBJECT,
//    Variant.BYTE_ARRAY,
  };

  // The values as they must appear in source code when generated by the VCD
  static String[] sourceStrings = {
    "borland.jbcl.util.Variant.UNASSIGNED_NULL", //NORES
    "borland.jbcl.util.Variant.ASSIGNED_NULL",   //NORES
    "borland.jbcl.util.Variant.BYTE",       //NORES
    "borland.jbcl.util.Variant.SHORT",      //NORES
    "borland.jbcl.util.Variant.INT",        //NORES
    "borland.jbcl.util.Variant.LONG",       //NORES
    "borland.jbcl.util.Variant.FLOAT",      //NORES
    "borland.jbcl.util.Variant.DOUBLE",     //NORES
    "borland.jbcl.util.Variant.BIGDECIMAL", //NORES
    "borland.jbcl.util.Variant.BOOLEAN",    //NORES
    "borland.jbcl.util.Variant.INPUTSTREAM",     //NORES
    "borland.jbcl.util.Variant.DATE",       //NORES
    "borland.jbcl.util.Variant.TIME",       //NORES
    "borland.jbcl.util.Variant.TIMESTAMP",  //NORES
    "borland.jbcl.util.Variant.STRING",     //NORES
    "borland.jbcl.util.Variant.OBJECT",     //NORES
//    "borland.jbcl.util.Variant.BYTE_ARRAY",  //NORES
  };

  static String[] getResourceStrings()
  {
    // We populate the resource strings strictly from the values[] array
    // so that reshuffling the order won't affect us
    String[] resourceStrings = new String[values.length /*Variant.MaxTypes*/];
    for (int i = 0; i < values.length; ++i) {
      resourceStrings[i] = Variant.typeName(values[i]);
      //if (Variant.typeOf(resourceStrings[i]) != values[i])
      //  System.err.println("values[" + i + "] containing " + values[i] + " is not " + resourceStrings[i]);
    }
    return resourceStrings;
  }

  /**
   * Returns the source code string for a given Variant data type
   */
  public static String getSourceCode(int iType) {
    if (iType < 0)
      iType = 0;
    return sourceStrings[iType];
  }
 
  /**
   * Returns the name as used in source code -- used by the DataTypeChoiceEditor
   */
/*
*  public static String sourceName(int type)
*  {
*    switch (type) {
*      case AssignedNull:      return "AssignedNull";   //NORES
*      case UnassignedNull:    return "UnassignedNull"; //NORES
*
*      case ByteType:          return "ByteType";       //NORES
*      case ShortType:         return "ShortType";      //NORES
*      case IntType:           return "IntType";        //NORES
*      case LongType:          return "LongType";       //NORES
*      case RealType:          return "RealType";       //NORES
*      case FloatType:         return "FloatType";      //NORES
*      case DoubleType:        return "DoubleType";     //NORES
*      case BigDecimalType:    return "BigDecimalType"; //NORES
*      case BooleanType:       return "BooleanType";    //NORES
*      case BinaryType:        return "BinaryType";     //NORES
*      case DateType:          return "DateType";       //NORES
*      case TimeType:          return "TimeType";       //NORES
*      case TimestampType:     return "TimestampType";  //NORES
*      case StringType:        return "StringType";     //NORES
*      case ByteArrayType:     return "ByteArrayType";  //NORES
*      case ObjectType:        return "ObjectType";     //NORES
*      default:                return "UnknownType";    //NORES
*    }
*  }
*/
}
