/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */

package borland.jbcl.editors;

import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import borland.jbcl.util.FastStringBuffer;
import borland.jbcl.layout.GridBagConstraints2;
import borland.jbcl.control.ButtonDialog;
import com.sun.java.swing.*;

public class DirectoryCustomEditor extends JComponent implements ActionListener {
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  Label label1 = new Label();
  Button button1 = new Button();
  TextField textField1 = new TextField();

  public DirectoryCustomEditor(String value) {
    try {
      jbInit();
      textField1.setText(value);
    }
    catch (Exception e ) {
      borland.jbcl.util.Diagnostic.printStackTrace(e);
    }
  }

  public void jbInit(){
    label1.setText(Res.getString(Res.DirectoryLabel));
    button1.setLabel(Res.getString(Res.Browse));
    this.setLayout(gridBagLayout1);
    this.add(label1, new GridBagConstraints2(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 10, 0, 0), 0, 0));
    this.add(button1, new GridBagConstraints2(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 10), 0, 0));
    this.add(textField1, new GridBagConstraints2(0, 1, 2, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 10, 10, 10), 0, 0));
    button1.addActionListener(this);
  }

  ButtonDialog findButtonDialog() {
    Component c = getParent();
    while (c != null && !(c instanceof ButtonDialog))
      c = c.getParent();
    if (c instanceof ButtonDialog)
      return (ButtonDialog)c;
    return null;
  }

  public void addNotify() {
    super.addNotify();
    ButtonDialog bd = findButtonDialog();
    if (bd != null) {
      bd.setEnterOK(true);
      bd.setEscapeCancel(true);
    }
  }

  public void actionPerformed(ActionEvent actionEvent) {
//    Frame f = getFrame();
    Frame f = new Frame();
    FileDialog dialog = new FileDialog(f,"", FileDialog.LOAD);
    dialog.setDirectory(textField1.getText());

    // FileDialog's don't report their preferredSize correctly, so
    // I'll hard-code some values for now...
    // Dimension frameSize = dialog.getPreferredSize();
    Dimension frameSize = new Dimension(420, 240);
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

    f.setLocation((screenSize.width - frameSize.width)/2, (screenSize.height - frameSize.height)/2);

    // Disable the parent dialog while the FileDialog is up...
    Component c = getParent();
    c.setEnabled(false);
    dialog.show();
    c.setEnabled(true);

//    filename =  dialog.getFile();
//    if (filename != null)
//      textField1.setText(dialog.getDirectory() + filename);
    textField1.setText(dialog.getDirectory());
  }

  Frame getFrame() {
    Component c = this;
    while (!(c instanceof Frame))
      c = c.getParent();
    return (Frame)c;
  }
}
