/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.jbcl.editors;

import java.beans.*;
import java.text.*;
import java.util.*;

import borland.jbcl.util.*;

public class LocaleNameEditor extends StringTagEditor
{
  static String[] resourceStrings;
  static String[] sourceCodeStrings;
  
  public LocaleNameEditor() {
    super(getResourceStrings(), getSourceCodeStrings());
  }

  static String[] getResourceStrings() {
    if (resourceStrings == null) {
      Locale[] locales = NumberFormat.getAvailableLocales();
      resourceStrings = new String[locales.length+1];
      sourceCodeStrings = new String[locales.length+1];
      resourceStrings[0] = Res.getString(Res.LOCALE_DEFAULT);
      sourceCodeStrings[0] = "";
      for (int i = 0; i < locales.length; ++i) {
        resourceStrings[i+1] = locales[i].getDisplayName() + " [" + locales[i].toString() + "]";
        sourceCodeStrings[i+1] = "\"" + locales[i].toString() + "\"";
      }
    }
    return resourceStrings;
  }
  static String[] getSourceCodeStrings() {
    return sourceCodeStrings;
  }
}
