/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.jbcl.editors;
import java.sql.*;

import borland.jbcl.util.*;
import borland.jbcl.dataset.ParameterType;

public class ParameterTypeEditor extends IntegerTagEditor
{
  public ParameterTypeEditor() {
    super(values, makeResourceStrings(), sourceStrings);
  }

  static String[] makeResourceStrings() {
    if (resourceStrings == null) {
      resourceStrings = new String[6];
      resourceStrings[0] = Res.getString(Res.NONE);
      resourceStrings[1] = Res.getString(Res.Parameter_In);
      resourceStrings[2] = Res.getString(Res.Parameter_Out);
      resourceStrings[3] = Res.getString(Res.Parameter_In_Out);
      resourceStrings[4] = Res.getString(Res.Parameter_Return);
      resourceStrings[5] = Res.getString(Res.Parameter_Result);
    }
    return resourceStrings;
  }

  static int[] values = {
                         ParameterType.NONE,
                         ParameterType.IN,
                         ParameterType.OUT,
                         ParameterType.IN_OUT,
                         ParameterType.RETURN,
                         ParameterType.RESULT,
                        };

  static String[] sourceStrings = {
                         "ParameterType.NONE",
                         "ParameterType.IN",
                         "ParameterType.OUT",
                         "ParameterType.IN_OUT",
                         "ParameterType.RETURN",
                         "ParameterType.RESULT"
                         };

  static String[] resourceStrings;
}

