/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.jbcl.editors;

import borland.jbcl.util.*;
import borland.jbcl.dataset.*;
import borland.sql.dataset.*;

public class SQLDialectEditor extends IntegerTagEditor
{
  public SQLDialectEditor() {
    super(values, makeResourceStrings(), sourceStrings);
  }

  static String[] makeResourceStrings() {
    if (resourceStrings == null) {
      resourceStrings = new String[3];
      resourceStrings[0] = Res.getString(Res.UNKNOWN);
      resourceStrings[1] = Res.getString(Res.INTERBASE);
      resourceStrings[2] = Res.getString(Res.ORACLE);
    }
    return resourceStrings;
  }

  static int[] values = {SQLDialect.UNKNOWN,
                         SQLDialect.INTERBASE,
                         SQLDialect.ORACLE,
                        };

  static String[] sourceStrings = {"borland.jbcl.dataset.SQLDialect.UNKNOWN",
                                   "borland.jbcl.dataset.SQLDialect.INTERBASE",
                                   "borland.jbcl.dataset.SQLDialect.ORACLE"};
  static String[] resourceStrings;
}
