/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.editors;

import java.awt.*;
import java.awt.event.*;
import borland.jbcl.model.*;
import borland.jbcl.control.*;
import com.sun.java.swing.*;

public class String2DArrayEditorPanel extends JComponent implements ActionListener
{
  GridControl   grid   = new GridControl();
  Panel         butPan = new Panel();
  Panel         rowPan = new Panel();
  Panel         colPan = new Panel();
  ButtonControl addRow = new ButtonControl();
  ButtonControl remRow = new ButtonControl();
  ButtonControl addCol = new ButtonControl();
  ButtonControl remCol = new ButtonControl();
  ButtonControl clear  = new ButtonControl();
  Label         label  = new Label();

  public String2DArrayEditorPanel() {
    super();
    butPan.setLayout(new GridLayout(0, 1, 10, 10));
    butPan.add(rowPan);
    butPan.add(colPan);
    butPan.add(addRow);
    butPan.add(remRow);
    butPan.add(clear);
    butPan.add(addCol);
    butPan.add(remCol);
    
    this.setLayout(new BorderLayout(10, 10));
    this.add(grid, BorderLayout.CENTER);
    this.add(butPan, BorderLayout.EAST);
    this.add(label, BorderLayout.NORTH);

    addRow.setLabel(Res.getString(Res.AddRow));
    addRow.addActionListener(this);
    remRow.setLabel(Res.getString(Res.RemoveRow));
    remRow.addActionListener(this);
    clear.setLabel(Res.getString(Res.Clear));
    clear.addActionListener(this);
    addCol.setLabel(Res.getString(Res.AddColumn));
    addCol.addActionListener(this);
    remCol.setLabel(Res.getString(Res.RemoveColumn));
    remCol.addActionListener(this);
    label.setText(Res.getString(Res.GridDirections));

    grid.setAutoAppend(true);   // users want to add rows from keyboard alone
  }

  public void actionPerformed(ActionEvent e) {
    Object src = e.getSource();
    MatrixLocation sf = grid.getSubfocus();
    if (src == addRow) {
      grid.addRow();
    }
    else if (src == remRow) {
      int rows = grid.getRowCount();
      if (rows > 1) {
        grid.removeRow(sf.row);
        if (sf.row == rows-1)
          grid.setSubfocus(sf.row-1, sf.column);
      }
    }
    else if (src == clear) {
      grid.removeAllRows();
      grid.addRow();
      grid.setSubfocus(0,0);
    }
    else if (src == addCol) {
      grid.addColumn();
    }
    else if (src == remCol) {
      int cols = grid.getColumnCount();
      if (cols > 1) {
        grid.removeColumn(sf.column);
        if (sf.column == cols-1)
          grid.setSubfocus(sf.row, sf.column-1);
      }
    }
  }

  public Insets getInsets() {
    return new Insets(10, 10, 5, 10);
  }
}
