/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.editors;

import java.awt.*;
import java.awt.event.*;
import borland.jbcl.util.*;
import borland.jbcl.model.*;
import borland.jbcl.view.Spacer;
import borland.jbcl.control.*;
import com.sun.java.swing.*;

public class StringArrayEditorPanel extends JComponent implements ActionListener, VectorSubfocusListener
{
  ListControl   list   = new ListControl();
  Panel         butPan = new Panel();
  ButtonControl add    = new ButtonControl();
  ButtonControl remove = new ButtonControl();
  ButtonControl clear  = new ButtonControl();
  ButtonControl up     = new ButtonControl();
  ButtonControl down   = new ButtonControl();

  public StringArrayEditorPanel() {
    super();
    butPan.setLayout(new GridLayout(0, 1, 10, 10));
    butPan.add(up);
    butPan.add(down);
    butPan.add(new Spacer());
    butPan.add(add);
    butPan.add(remove);
    butPan.add(clear);
    this.setLayout(new BorderLayout(10,10));
    this.add(list, BorderLayout.CENTER);
    this.add(butPan, BorderLayout.EAST);

    list.setShowRollover(true);
    list.setAutoInsert(false);
    list.addSubfocusListener(this);
    up.setLabel(Res.getString(Res.MoveUp));
    up.addActionListener(this);
    down.setLabel(Res.getString(Res.MoveDown));
    down.addActionListener(this);
    add.setLabel(Res.getString(Res.Add));
    add.addActionListener(this);
    remove.setLabel(Res.getString(Res.Remove));
    remove.addActionListener(this);
    clear.setLabel(Res.getString(Res.Clear));
    clear.addActionListener(this);
    checkButtons();
  }

  public void actionPerformed(ActionEvent e) {
    Object src = e.getSource();
    int sf = list.getSubfocus();
    int count = list.getCount();
    if (src == up) {
      if (count > 1 && sf > 0) {
        Object above = list.get(sf - 1);
        list.set(sf - 1, list.get(sf));
        list.set(sf, above);
        list.setSubfocus(sf - 1);
      }
    }
    else if (src == down) {
      if (count > 1 && sf < count - 1) {
        Object below = list.get(sf + 1);
        list.set(sf + 1, list.get(sf));
        list.set(sf, below);
        list.setSubfocus(sf + 1);
      }
    }
    else if (src == add) {
      list.safeEndEdit(true);
      list.addItem(Res.format(Res.ItemX,String.valueOf(count + 1)));
      list.setSubfocus(list.getCount() - 1);
      checkButtons();
    }
    else if (src == remove) {
      list.removeItem(sf);
      checkButtons();
    }
    else if (src == clear) {
      list.removeAllItems();
      checkButtons();
    }
  }

  public Insets getInsets() {
    return new Insets(10, 10, 5, 10);
  }

  void checkButtons() {
    int count = list.getCount();
    int sf = list.getSubfocus();
    if (count > 1) {
      if (sf == 0) {
        up.setEnabled(false);
        down.setEnabled(true);
      }
      else if (sf == count - 1) {
        up.setEnabled(true);
        down.setEnabled(false);
      }
      else {
        up.setEnabled(true);
        down.setEnabled(true);
      }
    }
    else {
      up.setEnabled(false);
      down.setEnabled(false);
    }
    if (count > 0) {
      remove.setEnabled(true);
      clear.setEnabled(true);
    }
    else {
      remove.setEnabled(false);
      clear.setEnabled(false);
    }
  }

  public void subfocusChanging(VectorSubfocusEvent e) throws VetoException {}
  public void subfocusChanged(VectorSubfocusEvent e) {
    checkButtons();
  }
}
