/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.jbcl.editors;

import borland.jbcl.util.*;

public class TriStateEditor extends IntegerTagEditor
{
  public TriStateEditor() {
    super(values, makeResourceStrings(), sourceStrings);
    //System.err.println("Tristate editor constructor");
  }

  static String[] makeResourceStrings() {
    if (resourceStrings == null) {
      resourceStrings = new String[3];
      resourceStrings[0] = Res.getString(Res.DEFAULT);
      resourceStrings[1] = Res.getString(Res.YES);
      resourceStrings[2] = Res.getString(Res.NO);

    }
    return resourceStrings;
  }

  static int[] values = {TriState.UNKNOWN, TriState.YES, TriState.NO};
  static String[] sourceStrings = {"borland.jbcl.util.TriState.UNKNOWN",    //NORES
                                   "borland.jbcl.util.TriState.YES",        //NORES
                                   "borland.jbcl.util.TriState.NO"};        //NORES
  static String[] resourceStrings;
}
