/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.jbcl.editors;

import borland.jbcl.util.*;
import borland.jbcl.dataset.*;

public class UpdateModeEditor extends IntegerTagEditor
{
  public UpdateModeEditor() {
    super(values, makeResourceStrings(), sourceStrings);
  }

  static String[] makeResourceStrings() {
    if (resourceStrings == null) {
      resourceStrings = new String[4];
      resourceStrings[0] = Res.getString(Res.Unassigned);
      resourceStrings[1] = Res.getString(Res.WhereAll);
      resourceStrings[2] = Res.getString(Res.WhereKeyOnly);
      resourceStrings[3] = Res.getString(Res.WhereChanged);
    }
    return resourceStrings;
  }

  static int[] values =           {UpdateMode.UNASSIGNED,
                                   UpdateMode.ALL_COLUMNS,
                                   UpdateMode.KEY_COLUMNS,
                                   UpdateMode.CHANGED_COLUMNS,
                                   };
  static String[] sourceStrings = {"borland.jbcl.dataset.UpdateMode.UNASSIGNED",
                                   "borland.jbcl.dataset.UpdateMode.ALL_COLUMNS",
                                   "borland.jbcl.dataset.UpdateMode.KEY_COLUMNS",
                                   "borland.jbcl.dataset.UpdateMode.CHANGED_COLUMNS",
                                   };
  static String[] resourceStrings;
}
