/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */

package borland.jbcl.io;

import java.io.*;

public class BufferedInputFile extends BufferedInputStream
{
  FileInputStream f;
  StringBuffer    buffer;

  public BufferedInputFile(String path) throws FileNotFoundException {
    super(new FileInputStream(path));
    f = (FileInputStream)in;
    buffer = new StringBuffer(128);
  }

  public final void close() throws IOException {
    f.close();
  }

  public final String readLine() throws IOException {

    // Reuse buffer to avoid allocating memory over and over.
    //
    buffer.setLength(0);

    int ch;
    while ((ch = read()) != -1) {
      if (ch == '\r')
        continue;
      if (ch == '\n')
        break;

      buffer.append((char)ch);
    }

    // Note toString is documented as not copying the buffer (avoids another
    // allocation).
    //
    if (buffer.length() > 0)
      return buffer.toString();

    return null;
  }
}
