/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */

package borland.jbcl.io;

import java.io.*;
import java.util.*;

public interface FileSystem
{
  String createFilePath(String path, String file);

  void copyFile(String src, String dest) throws IOException;

  void copyFile(String src, String dest, String header) throws IOException;

  boolean compareBytes(byte[] buf1, byte[] buf2, int count);

  boolean compareFiles(String path1, String path2) throws IOException;

  void deleteDirectoryTree(String dirPath) throws Exception;

  boolean traverse(TraverseAction act, File dir) throws Exception;

  Properties loadProperties(String path) throws IOException;

  boolean makeDirs(String path);

  boolean makeDir(String path);

  String addDir(String path, String dir);

  // This is here because the list() method of the File class returns a String[]
  int listContains(String[] baseList, String name);

  File newFile(String path);

  File getClassesFile(String file);
  File getClassesFile(Object object);
}
