/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package borland.jbcl.model;

import borland.jbcl.util.Variant;
import java.io.*;
import java.util.*;
import java.math.*;

public class BigDecimalFormatter extends VariantFormatter implements Serializable
{
  private int scale = -1;
  public BigDecimalFormatter(int scale) {
    super();
    this.scale = scale;
//    System.err.println("BigDecimalFormatter(" + this.scale + ")");
  }

  public String format(Variant value) {
//    return new BigDecimal(value.getBigDecimal()).toString(); 
    String s =  (value == null || value.isNull())
              ? ""
              : (scale >= 0)
                  ? value.getBigDecimal().setScale(scale, BigDecimal.ROUND_HALF_UP).toString()
                  : value.getBigDecimal().toString();
//    System.err.println("format of " + value + " is: " + s);
    return s;
  }


  public void parse(String stringValue, Variant value) {
//    value.setBigDecimal(new BigDecimal(stringValue, scale)); 
    if (stringValue == null || stringValue.length() == 0) {
      value.setUnassignedNull();
      return;
    }
    BigDecimal bn = new BigDecimal(stringValue);
    if (scale >= 0) {
//      System.err.println("BigDecimalFormatter.parse() overriding scale of " + bn.scale() + " with " + this.scale);
      bn = bn.setScale(scale, BigDecimal.ROUND_HALF_UP);
    }
    value.setBigDecimal(bn /*new BigDecimal(stringValue)*/);
//    System.err.println("BigDecimalFormatter.parse(" + stringValue + ") gives: " + value);
  }

  /*!
  public void parse(Variant variant, char[] value, int offset, int len) {
    if (len == 0)
      variant.setUnassignedNull();
    else
      variant.setBigDecimal(new BigDecimal(new String(value, offset, len), scale));
  }
  */

  public int getVariantType() { return Variant.BIGDECIMAL; }

}
