/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.model;
import borland.jbcl.util.Variant;
import borland.jbcl.util.Diagnostic;
import java.lang.Character;
import java.io.*;

// Not public.
//
public class BooleanFormatter extends VariantFormatter implements Serializable
{
  public BooleanFormatter() {
    super();
  }

  public final String format(Variant value) {
    if (value == null || value.isNull())
      return "";

    if (value.getBoolean())
      return Res.getString(Res.True);
    else
      return Res.getString(Res.False);
  }

  public final void parse(String stringValue, Variant value) {
    if (stringValue.length() > 0) {
      value.setBoolean(stringValue.equalsIgnoreCase(Res.getString(Res.True)));
    }
    else
      value.setAssignedNull();
  }

  public int getVariantType() { return Variant.BOOLEAN; }
}
