/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//------------------------------------------------------------------------------

package borland.jbcl.model;

import java.awt.*;

/**
 *
 */
public interface CustomPaintSite extends ItemPaintSite
{
  /**
   * The reset method reassigns all set values back to the defaults provided
   * by the original ItemPaintSite.
   */
  public void reset();

  /**
   * The background color for the item being painted.
   * @param color A java.awt.Color object representing the background color.
   */
  public void setBackground(Color color);

  /**
   * The foreground color for the item being painted.
   * @param color A java.awt.Color object representing the foreground color.
   */
  public void setForeground(Color color);

  /**
   * The font to use for the item being painted.
   * @param font A java.awt.Font object representing the font to use.
   */
  public void setFont(Font font);

  /**
   * The alignment setting for the item being painted.
   * @see borland.util.Alignment for alignment settings.
   * @param alignment An int representing the alignment bitmask.
   */
  public void setAlignment(int alignment);

  /**
   * The item margins for the item being painted.
   * @param margins An Insets object representing the margins for this item.
   */
  public void setItemMargins(Insets margins);
}
