/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.model;

import java.sql.*;
import java.io.*;
import borland.jbcl.util.Variant;

public class DateFormatter extends VariantFormatter implements Serializable
{
  public DateFormatter() {
    super();
  }

  public final String format(Variant value) {
    // Note: toString and valueOf use JDBC date escape syntax so must agree with each other
    return (value == null || value.isNull())
              ? ""
              : (new java.util.Date((value).getDate().getTime())).toGMTString();

  }


  public final void parse(String stringValue, Variant value) {
    if (stringValue == null || stringValue.length() == 0) {
      value.setUnassignedNull();
      return;
    }
    Date date = new java.sql.Date(70, 0, 1);
    try {
      date.setTime(new java.util.Date(stringValue).getTime());
      // Note: we use util date since it has a smarter constructor and will parse GMT time
    }
    catch (RuntimeException ex) {
      System.out.println("Format error "+ stringValue);
      throw ex;
    }
    value.setDate(date);

  }

  /*!
  public void parse(Variant variant, char[] value, int offset, int len) {
    if (len == 0)
      variant.setUnassignedNull();
    else {
      Date date = null;
      // TODO. When sun surfaces a java.sql.Date(string) constructor,
      // stop making two allocations.
      //
      // TODO.  How should time zone be handled. - local for display, but
      // perhaps GMT for export/import?
      //
      date = new java.sql.Date(70, 1, 1);

      try {
        date.setTime(new java.sql.Date(new String(value, offset, len)).getTime());
      }
      catch (RuntimeException ex) {
        System.out.println("DateFormatter: parse exception on "+new String(value, offset, len));
  variant.setUnassignedNull();
        throw ex;
      }
      variant.setDate(date);
    }
  }
  */

  public int getVariantType() { return Variant.DATE; }

}
