/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */

package borland.jbcl.model;

import borland.jbcl.util.Variant;
import borland.jbcl.model.VariantFormatter;
import java.io.Serializable;

public class ObjectFormatter extends VariantFormatter implements Serializable
{
  public ObjectFormatter() {
    super();
  }

  public final String format(Variant value) {
    Object obj = value.getObject();
    return obj == null ? "" : obj.toString();
  }

  public void parse(String stringValue, Variant value) {
    value.setObject(stringValue);
  }

  public void parse(Variant variant, char[] value, int offset, int len) {
    variant.setObject(null);
  }

  public int getVariantType() { return Variant.OBJECT; }
}
