/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */

package borland.jbcl.model;

import borland.jbcl.util.Variant;
import borland.jbcl.model.VariantFormatter;
import java.io.*;

public class StringFormatter extends VariantFormatter implements Serializable
{
  public StringFormatter() {
    super();
  }

  public final String format(Variant value) {
    return value.getString();
  }

  public void parse(String stringValue, Variant value) {
    value.setString(stringValue);
  }

  public void parse(Variant variant, char[] value, int offset, int len) {
    // Import code relies on this to create an empty string if len == 0
    // ie don't set it to null.  (SteveS).
    //
    variant.setString(new String(value, offset, len));
  }

  public int getVariantType() { return Variant.STRING; }

}
