/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */

package borland.jbcl.model;

import java.sql.*;
import borland.jbcl.util.Variant;
import java.io.*;

public class TimestampFormatter extends VariantFormatter implements Serializable
{
  public TimestampFormatter() {
    super();
  }

  public final String format(Variant value) {
    return (value == null || value.isNull())
              ? ""
              : value.getTimestamp().toString();
    // Note: toString and valueOf use JDBC date escape syntax so must agree with each other
  }

  public final void parse(String stringValue, Variant value) {
    java.sql.Timestamp t = java.sql.Timestamp.valueOf(stringValue);  // uses JDBC date escape form
    value.setTimestamp(t);
  }

  public void parse(Variant variant, char[] value, int offset, int len) {
    if (len == 0)
      variant.setUnassignedNull();
    else
      variant.setTimestamp(java.sql.Timestamp.valueOf(new String(value, offset, len)));
  }

  public int getVariantType() { return Variant.TIME; }

}
