/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.util;

/**
 * general purpose 2D alignment constants for aligning something within a
 * rectangle. Can use zero or one from each of the two groups
 */
public class Alignment
{
  // Uninitialized state.
  //
  public static final int UNDEFINED  = 0x00;

  // Horizontal alignment
  public static final int LEFT       = 0x01;
  public static final int CENTER     = 0x02;
  public static final int RIGHT      = 0x03;
  public static final int HSTRETCH   = 0x04;
  public static final int HORIZONTAL = 0x0F;

  // Vertical alignment
  public static final int TOP      = 0x10;
  public static final int MIDDLE   = 0x20;
  public static final int BOTTOM   = 0x30;
  public static final int VSTRETCH = 0x40;
  public static final int VERTICAL = 0xF0;

  private static final int ALL = LEFT|CENTER|RIGHT|HSTRETCH|TOP|MIDDLE|BOTTOM|VSTRETCH|VERTICAL|HORIZONTAL;

  public static final boolean valid(int alignment) {
    return (alignment & ALL) == alignment;
  }
}
