/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.util;

/**
 * Used for collecting a response to an error from a component.
 */
public class ErrorResponse
{
  public ErrorResponse() {
    response  = ABORT;
  }
  public static final int ABORT   = 1;
  public static final int IGNORE  = 2;
  public static final int RETRY   = 3;

  /** Call this to fail the operation with an Exception throw.
  */
  public final void abort() { response  = ABORT; }
  /** Call this to silently fail the operation without throwing
      an exception
  */
  public final void ignore() { response  = IGNORE; }
  /** Call this to attempt to retry the operation that failed.
  */
  public final void retry() { response  =  RETRY; }

  public final int getResponse() { return response;}

  public final boolean isAbort() { return response == ABORT; }
  public final boolean isIgnore() { return response == IGNORE; }
  public final boolean isRetry() { return response == RETRY; }

  private int response;
}
