/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.util;

public class ExceptionChain implements java.io.Serializable {

  public ExceptionChain() {
  }

  private ExceptionChain(ExceptionChain next, Exception ex) {
    this.next = next;
    this.ex = ex;
  }

  public void append(Exception ex) {
    if (this.ex == null)
      this.ex = ex;
    else
      next = new ExceptionChain(next, ex);
  }

  public void printStackTrace(java.io.PrintStream out) {
    printStackTrace(this, out);
  }

  private void printStackTrace(ExceptionChain exChain, java.io.PrintStream out) {
    if (exChain != null && exChain.next != null)
      exChain.printStackTrace(exChain.next, out);
    if (ex != null)
      ex.printStackTrace(out);
  }

  public boolean        hasExceptions() { return ex != null; }
  public ExceptionChain getNext() { return next; }
  public Exception      getException() { return ex; }

  private ExceptionChain next;
  private Exception      ex;
}
