/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.util;

import java.io.InputStream;
import java.io.IOException;
import java.io.ByteArrayInputStream;

/**
 * This class is a wrapper around ByteArrayInputStream.
 * The DataSet package need access to the byte array itself when resolving.
 *
 * @author  Jens Ole Lauridsen
 * @version 1.01 8/26/97
 * @see     java.io.ByteArrayInputStream
 */
public class InputStreamToByteArray extends ByteArrayInputStream
{
  public InputStreamToByteArray(byte buf[]) {
    super(buf);
  }
  public InputStreamToByteArray(byte buf[], int offset, int length) {
    super(buf, offset, length);
  }

  public byte[] getBytes() {
    return buf;
  }

  static public byte[] getBytes(InputStream stream) throws IOException {
    InputStreamToByteArray buffer;
    if (stream instanceof InputStreamToByteArray) {
      buffer = (InputStreamToByteArray)stream;
      return buffer.getBytes();
    }
    else {
      byte[] buf = new byte[stream.available()];
      stream.read(buf);
      return buf;
    }
  }
}
