/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.util;

import java.awt.*;
import com.sun.java.swing.*;

public class LookAndFeelManager
{
  public LookAndFeelManager() {}

  public void setLookAndFeel(LookAndFeel lookAndFeel) {
    try {
      UIManager.setLookAndFeel(lookAndFeel);
      updateUI();
    }
    catch (Exception x) {
      throw new IllegalArgumentException(x.getMessage());
    }
  }
  public LookAndFeel getLookAndFeel() {
    return UIManager.getLookAndFeel();
  }

  public void setRootComponent(Component rootComponent) {
    this.rootComponent = rootComponent;
    updateUI();
  }

  public Component getRootComponent() {
    return rootComponent;
  }

  public void updateUI() {
    if (rootComponent != null) {
      SwingUtilities.updateComponentTreeUI(rootComponent);
      rootComponent.validate();
    }
  }

  protected transient Component rootComponent;
}
