/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.util;

/**
 * VetoException is thrown when an EventListener wishes to halt multicasting of a vetoable event.
 */
public class VetoException extends java.lang.Exception
{
  /**
   * Constructs an VetoException with no detail message.
   */
  public VetoException() {
    super();
    vetoMessage = null;
  }

  /**
   * Provides the application the oppurtunity to pass a message for default error message handling.
   * Many event processers will ignore the vetoMessage. The vetoMessage is not required.
   */
  public VetoException(String vetoMessage) {
    super(vetoMessage);
    this.vetoMessage  = vetoMessage;
  }

  public String getVetoMessage() {
    return vetoMessage;
  }

  private String vetoMessage;
}
