/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.view;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import borland.jbcl.util.*;
import borland.jbcl.model.*;
import com.sun.java.swing.*;
import java.io.Serializable;

// This the columnHeader's default model and view manager
// this can be overridden by subclassing GridView and implementing createDefaultColumnHeaderView()
public class DefaultColumnHeaderManager implements VectorViewManager, VectorModel, MatrixModelListener, Serializable
{
  public DefaultColumnHeaderManager(GridView grid) {
    this.grid = grid;
  }

  public ItemPainter getPainter(int index, Object data, int state) { return painter; }
  public ItemEditor getEditor(int index, Object data, int state) { return null; }

  public Object get(int index) {
    ColumnView cv = grid.getColumnView(index);
    String caption = cv != null ? cv.getCaption() : null;
    if (caption == null)
      caption = Res.format(Res.Column, new String[] {String.valueOf(index)});
    return caption;
  }

  public int find(Object data) { return -1; }
  public int getCount() { return grid.getModel().getColumnCount(); }

  public void addModelListener(VectorModelListener listener) {
    modelListeners.add(listener);
    if (modelListeners.getListenerCount() == 1)
      grid.addModelListener(this);
  }
  public void removeModelListener(VectorModelListener listener) {
    modelListeners.remove(modelListeners, listener);
    if (modelListeners.getListenerCount() == 0)
      grid.removeModelListener(this);
  }
  protected void processModelEvent(VectorModelEvent e) { modelListeners.dispatch(e); }

  public void modelContentChanged(MatrixModelEvent e) {}
  public void modelStructureChanged(MatrixModelEvent e) {
    processModelEvent(new VectorModelEvent(this, VectorModelEvent.ITEM_ADDED, 0));
  }

  private transient borland.jbcl.util.EventMulticaster modelListeners = new borland.jbcl.util.EventMulticaster();
  private GridView grid;
  private ItemPainter painter = new ButtonItemPainter(new FocusableItemPainter(new EllipsisTextItemPainter(Alignment.CENTER | Alignment.MIDDLE, new Insets(0,2,0,2))));
}

