/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.view;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import borland.jbcl.util.*;
import borland.jbcl.model.*;

public class ImageItemEditor extends Canvas implements ItemEditor, java.io.Serializable
{
  public ImageItemEditor() {
    variant = new Variant();
    variant.setInputStream(null);
  }

  public Component getComponent() { return this; }

  public void startEdit(Object data, Rectangle bounds, ItemEditSite site) {
    Component component = site != null ? site.getSiteComponent() : this;
    while (component != null && !(component instanceof Frame))
      component = component.getParent();
    if (component instanceof Frame) {
      FileDialog dialog = new FileDialog((Frame)component, Res.getString(Res.SelectImageFile), FileDialog.LOAD);
      dialog.setDirectory(null);
      dialog.show();
      String dir = dialog.getDirectory();
      String file = dialog.getFile();
      if (dir != null && file != null) {
        String name = dir + file;
        try {
          FileInputStream stream = new FileInputStream(name);
          byte[] bytes = byteArrayFromStream(stream);
          variant.setInputStream(new ByteArrayInputStream(bytes));
          site.safeEndEdit(true);
        }
        catch (Exception ex) {
          Diagnostic.printStackTrace(ex);
          Diagnostic.fail();
        }
      }
      else {
        // dialog was cancelled
        site.safeEndEdit(false);
      }
    }
    else
      throw new RuntimeException(Res.getString(Res.FileDialogNoFrame));
  }

  private static byte[] byteArrayFromStream(InputStream s) throws IOException {
    int len = s.available();
    byte[] buf = new byte[len];
    for (int count = 0; count < len; ) {
      int n = s.read(buf, count, len-count);
      if (n < 0)
        return null; // error reading data
      count += n;
    }
    return buf;
  }

  public Object getValue() {
    return variant.getInputStream();
  }

  public void changeBounds(Rectangle bounds) {
  }

  public boolean canPost() {
    return true;
  }

  public void endEdit(boolean posted) {
  }

  public void addKeyListener(KeyListener l) {
    // No Key Events!
  }
  public void removeKeyListener(KeyListener l) {
    // No Key Events!
  }

  private Variant variant;
}
