/*
 * @(#)MacTableUI.java	1.4 98/02/02
 *
 * Copyright (c) 1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */
 
 
package com.sun.java.swing.plaf.mac;

import com.sun.java.swing.plaf.basic.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import java.util.Enumeration;
import java.awt.event.*;
import java.awt.*;
import com.sun.java.swing.plaf.*;
import java.io.Serializable;

/**
 * MacTableUI implementation
 * <p>
 * Warning: serialized objects of this class will not be compatible with
 * future swing releases.  The current serialization support is appropriate
 * for short term storage or RMI between Swing1.0 applications.  It will
 * not be possible to load serialized Swing1.0 objects with future releases
 * of Swing.  The JDK1.2 release of Swing will be the compatibility
 * baseline for the serialized form of Swing objects.
 *
 * @version 1.0 01/15/98
 * @author Symantec
 * @author David Bustin
 */
public class MacTableUI extends BasicTableUI
{
//
// Install/Deinstall UI
//

    public static ComponentUI createUI(JComponent c) {
        return new MacTableUI();
    }
    public void installUI(JComponent c) {
        super.installUI(c);
		table.setGridColor(UIManager.getColor("Table.gridColor"));
		table.setForeground(UIManager.getColor("Table.foreground"));
		table.setBackground(UIManager.getColor("Table.background"));
		}
		
    public void uninstallUI(JComponent c) {
        super.installUI(c);
    }
    public void paint(Graphics g, JComponent c) {

		super.paint(g,c);

		TableHeaderUI mui = table.getTableHeader().getUI();
		if (mui instanceof MacTableHeaderUI)
		{
			((MacTableHeaderUI)mui).repaintLastSelectedColumn();	// un-select last column header
		}
	}
	
}  // End of Class MacTableUI

