/*
 * @(#)OrganicRolloverButtonBorder.java	1.4 98/02/02
 * 
 * Copyright (c) 1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */
 
package com.sun.java.swing.plaf.organic;

import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
import com.sun.java.swing.plaf.basic.*;
import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.plaf.*;

/**
 * ROLLOVER BUTTON BORDER
 *  Rollover boders have no "safety border" - a extra line of 
 *   khaki that may separate them visually from other objects
 *   or the background color.
 * <p>
 * Warning: serialized objects of this class will not be compatible with
 * future swing releases.  The current serialization support is appropriate
 * for short term storage or RMI between Swing1.0 applications.  It will
 * not be possible to load serialized Swing1.0 objects with future releases
 * of Swing.  The JDK1.2 release of Swing will be the compatibility
 * baseline for the serialized form of Swing objects.
 *
 * @version 1.4 02/02/98
 * @author Michael C. Albers
 * @author Tom Santos
 */
public class OrganicRolloverButtonBorder extends OrganicButtonBorder {

  protected int getSafetyBorderWidth() { return 0; }
  protected int getDefaultBorderWidth() { return 0; }

  public void paintBorder(Component c, Graphics g, int x, int y, 
			  int w, int h) {
      AbstractButton b = (AbstractButton)c;
      DefaultButtonModel model = (DefaultButtonModel)b.getModel();

      if ( model.isRollover() && !(model.isPressed() && !model.isArmed()) ) {
	  super.paintBorder( c, g, x, y, w, h );
      }
  }

  public Insets getBorderInsets(Component c)       {
    return new Insets(0, 0, 0, 0);
  }
}
