/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1998 Borland International, Inc. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package borland.jbcl.model;

import java.util.EventListener;
import borland.jbcl.util.*;
import java.io.*;

public class GraphSubfocusEvent extends SubfocusEvent implements VetoableDispatch, Serializable
{
  private static final long serialVersionUID = 200L;

  public GraphSubfocusEvent(Object source, int id, GraphLocation location) {
    super(source, id);
    this.location = location;
  }

  public GraphLocation getLocation() { return location; }

  public void vetoableDispatch(EventListener listener) throws VetoException {
    Diagnostic.check(getID() == SUBFOCUS_CHANGING);
    ((GraphSubfocusListener)listener).subfocusChanging(this);
  }

  public void dispatch(EventListener listener) {
    Diagnostic.check(getID() == SUBFOCUS_CHANGED);
    ((GraphSubfocusListener)listener).subfocusChanged(this);
  }

  protected String paramString() {
    return super.paramString() + ",location=" + location;  //NORES
  }

  // Serialization support

  private void writeObject(ObjectOutputStream s) throws IOException {
    s.defaultWriteObject();
    s.writeObject(location instanceof Serializable ? location : null);
  }

  private void readObject(ObjectInputStream s) throws IOException, ClassNotFoundException {
    s.defaultReadObject();
    Object data = s.readObject();
    if (data instanceof GraphLocation)
      location = (GraphLocation)data;
  }

  private transient GraphLocation location;
}
